# -*- coding: utf-8 -*-
# 게임 화면 상수정의
#
#   This file is part of otak-godori.
#
#   Copyright (C) 2007 Otak-godori Project.
#
#   This program is free software; you can redistribute it and/or modify it
#   under the terms of the GNU General Public License as published by the
#   Free Software Foundation; either version 3, or (at your option) any later
#   version.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
#   Public License for more details.
#
#   You should have received a copy of the GNU General Public License along
#   with this program; if not, write to the Free Software Foundation, Inc.,
#   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  

from widget.ogcard import *

##############################################################################
# UI. 기본정보
##############################################################################

# 총 화투장 수
CARD_CNT = 48
# 바닥에 화투장 깔 공간 수
SPRD_CNT = 16
# 바닥에 화투장 깔 공간당 화투장 수
CARD_CNT_IN_SPRD = 6
# 플레이어 수
PLYR_CNT = 2
# 플레이어당 가지는 숨겨진 화투장 최대수
PLYR_HIDN_CNT = 10
# 점수패 광 최대 수
PLYR_PNT_LHGT_CNT = 5
# 점수패 열끗 최대수
PLYR_PNT_TEN_CNT = 9
# 점수패 띠 최대수
PLYR_PNT_BELT_CNT = 10
# 점수패 피(껍데기) 최대수
PLYR_PNT_COVR_CNT = 27
# 라운드 시작시 화투장 나누어줄때 딜레이 시간. 1 second
DST_STEP_TIME = 0.15
# 내 플레이어 인덱스. 선, 후를 따니는게 아니고 위아래 공간 정도
MY_PLYR_ID = 1

# 화투장 비의 카드번호
CARD_RAIN_NUM = 12
# 유효 점수 (나는 점수)
VALID_PNT = 7

##############################################################################
# UI. 화투장 아이템
##############################################################################

# 화투장 기본 넓이
CARD_NML_WIDTH = 35
# 화투장 기본 높이
CARD_NML_HEIGHT = 54

##############################################################################
# UI. 화투장 위치 및 크기
##############################################################################

# 가운데 패와 바닥패 사이 옆 간격
CARD_SPC_OPEN_FROM_REMN_W = 75
# 가운데 패와 바닥패 사이 위아래 간격
CARD_SPC_OPEN_FROM_REMN_H = 30
# 바닥패들의 사이 간격
CARD_SPC_OPEN = 30
# 바닥패가 여러장 쌓일경우 사선 간격
CARD_SPC_OVER = 6

# 가운데 패 X 좌표
CARD_PSTN_REMN_X = 200
# 가운데 패 Y 좌표
CARD_PSTN_REMN_Y = 273

# 바닥패 위 X, Y 좌표
def CARD_PSTN_OPEN_TOP_X(id):
    return (CARD_PSTN_REMN_X - (CARD_NML_WIDTH / 2) - (CARD_SPC_OPEN / 2)) \
        + ((CARD_NML_WIDTH + CARD_SPC_OPEN) * id)
def CARD_PSTN_OPEN_TOP_Y():
    return CARD_PSTN_REMN_Y - CARD_NML_HEIGHT - CARD_SPC_OPEN_FROM_REMN_H

# 바닥패 오른쪽 X, Y 좌표
def CARD_PSTN_OPEN_RIGHT_X():
    return CARD_PSTN_REMN_X + CARD_NML_WIDTH + CARD_SPC_OPEN_FROM_REMN_W
def CARD_PSTN_OPEN_RIGHT_Y(id):
    return (CARD_PSTN_REMN_Y - (CARD_NML_HEIGHT / 2) - (CARD_SPC_OPEN / 2)) \
        + ((CARD_NML_HEIGHT + CARD_SPC_OPEN) * id)

# 바닥패 아래쪽 X, Y 좌표
def CARD_PSTN_OPEN_BOTTOM_X(id):
    return CARD_PSTN_OPEN_TOP_X(id)
def CARD_PSTN_OPEN_BOTTOM_Y():
    return CARD_PSTN_REMN_Y + CARD_NML_HEIGHT + CARD_SPC_OPEN_FROM_REMN_H

# 바닥패 왼쪽 X, Y 좌표
def CARD_PSTN_OPEN_LEFT_X():
    return CARD_PSTN_REMN_X - CARD_NML_WIDTH - CARD_SPC_OPEN_FROM_REMN_W
def CARD_PSTN_OPEN_LEFT_Y(id):
    return CARD_PSTN_OPEN_RIGHT_Y(id)


# 플레이어 패 사이 간격
CARD_SPC_PLYR_HIDDEN = 2
# 플레이어 패 한줄에 놓는 수
CARD_COUNT_PLYR_BY_LINE = 10
# 플레이어 먹은패 곂쳐놓는 간격
CARD_SPC_PSTN = 12

# 플레이어 패 X, Y 좌표
def CARD_PSTN_PLYR_HIDN_X(plyr_id, id):
    x = 0
    if plyr_id == 0:
        x = 30
    else:
        x = 30
    return x + ((id % CARD_COUNT_PLYR_BY_LINE)
                * (CARD_NML_WIDTH + CARD_SPC_PLYR_HIDDEN))
def CARD_PSTN_PLYR_HIDN_Y(plyr_id, line_id):
    y = 0
    if plyr_id == 0:
        y = 30
    else:
        y = 516
    return y + ((line_id) * (CARD_NML_HEIGHT + CARD_SPC_PLYR_HIDDEN))

# 먹은 점수패 광
def CARD_PSTN_PLYR_PNT_LGHT_X(plyr_id, id):
    x = 0
    if plyr_id == 0:
        x = 430
    else:
        x = 430
    return x + (CARD_SPC_PSTN * id)
def CARD_PSTN_PLYR_PNT_LGHT_Y(plyr_id):
    if plyr_id == 0:
        return 30
    else:
        return 516

# 먹은 점수패 열끗
def CARD_PSTN_PLYR_PNT_TEN_X(plyr_id, id):
    x = 0
    if plyr_id == 0:
        x = 523
    else:
        x = 523
    return x + (CARD_SPC_PSTN * id)
def CARD_PSTN_PLYR_PNT_TEN_Y(plyr_id):
    if plyr_id == 0:
        return 85
    else:
        return 461

# 먹은 점수패 띠
def CARD_PSTN_PLYR_PNT_BLT_X(plyr_id, id):
    x = 0
    if plyr_id == 0:
        x = 523
    else:
        x = 523
    return x + (CARD_SPC_PSTN * id)
def CARD_PSTN_PLYR_PNT_BLT_Y(plyr_id):
    if plyr_id == 0:
        return 30
    else:
        return 516

# 먹은 점수패 피(껍데기)
def CARD_PSTN_PLYR_PNT_CVR_X(plyr_id, id):
    x = 0
    if plyr_id == 0:
        x = 676
    else:
        x = 676
    return x + (CARD_SPC_PSTN * (id % 5))
def CARD_PSTN_PLYR_PNT_CVR_Y(plyr_id, id):
    if plyr_id == 0:
        return 30  + ((id / 5) * (CARD_NML_HEIGHT + 1))
    else:
        return 516 - ((id / 5) * (CARD_NML_HEIGHT + 1))

##############################################################################
# 화투장 배열에 각각 타입 정의
##############################################################################
CARD_TYPES = (
    # 1 송학
    (OG_CARD_TYPE_LIGHT, OG_CARD_SUB_TYPE_NONE), # 광
    (OG_CARD_TYPE_BELT, OG_CARD_SUB_TYPE_RED), # 띠, 청단
    (OG_CARD_TYPE_COVER, OG_CARD_SUB_TYPE_NONE), # 피
    (OG_CARD_TYPE_COVER, OG_CARD_SUB_TYPE_NONE), # 피
    # 2 매조
    (OG_CARD_TYPE_TEN, OG_CARD_SUB_TYPE_BIRD), # 열끗, 고도리
    (OG_CARD_TYPE_BELT, OG_CARD_SUB_TYPE_RED), # 띠, 홍단
    (OG_CARD_TYPE_COVER, OG_CARD_SUB_TYPE_NONE), # 피
    (OG_CARD_TYPE_COVER, OG_CARD_SUB_TYPE_NONE), # 피
    # 3 벚꽃
    (OG_CARD_TYPE_LIGHT, OG_CARD_SUB_TYPE_NONE), # 광
    (OG_CARD_TYPE_BELT, OG_CARD_SUB_TYPE_RED), # 띠, 홍단
    (OG_CARD_TYPE_COVER, OG_CARD_SUB_TYPE_NONE), # 피
    (OG_CARD_TYPE_COVER, OG_CARD_SUB_TYPE_NONE), # 피
    # 4 흑싸리
    (OG_CARD_TYPE_TEN, OG_CARD_SUB_TYPE_BIRD), # 열끗, 고도리 
    (OG_CARD_TYPE_BELT, OG_CARD_SUB_TYPE_GRASS), # 띠, 초단
    (OG_CARD_TYPE_COVER, OG_CARD_SUB_TYPE_NONE), # 피
    (OG_CARD_TYPE_COVER, OG_CARD_SUB_TYPE_NONE), # 피
    # 5 난초
    (OG_CARD_TYPE_TEN, OG_CARD_SUB_TYPE_NONE), # 열끗
    (OG_CARD_TYPE_BELT, OG_CARD_SUB_TYPE_GRASS), # 띠, 초단
    (OG_CARD_TYPE_COVER, OG_CARD_SUB_TYPE_NONE), # 피
    (OG_CARD_TYPE_COVER, OG_CARD_SUB_TYPE_NONE), # 피
    # 6 모란 */
    (OG_CARD_TYPE_TEN, OG_CARD_SUB_TYPE_NONE), # 열끗
    (OG_CARD_TYPE_BELT, OG_CARD_SUB_TYPE_BLUE), # 띠, 청단
    (OG_CARD_TYPE_COVER, OG_CARD_SUB_TYPE_NONE), # 피
    (OG_CARD_TYPE_COVER, OG_CARD_SUB_TYPE_NONE), # 피
    # 7 홍싸리 */
    (OG_CARD_TYPE_TEN, OG_CARD_SUB_TYPE_NONE), # 열끗
    (OG_CARD_TYPE_BELT, OG_CARD_SUB_TYPE_GRASS), # 띠, 초단
    (OG_CARD_TYPE_COVER, OG_CARD_SUB_TYPE_NONE), # 피
    (OG_CARD_TYPE_COVER, OG_CARD_SUB_TYPE_NONE), # 피
    # 8 공산
    (OG_CARD_TYPE_LIGHT, OG_CARD_SUB_TYPE_NONE), # 광
    (OG_CARD_TYPE_TEN, OG_CARD_SUB_TYPE_BIRD), # 열끗, 고도리
    (OG_CARD_TYPE_COVER, OG_CARD_SUB_TYPE_NONE), # 피
    (OG_CARD_TYPE_COVER, OG_CARD_SUB_TYPE_NONE), # 피
    # 9 국준
    (OG_CARD_TYPE_TEN, OG_CARD_SUB_TYPE_DOUBLE), # 열끗, 쌍피
    (OG_CARD_TYPE_BELT, OG_CARD_SUB_TYPE_BLUE), # 띠, 청단
    (OG_CARD_TYPE_COVER, OG_CARD_SUB_TYPE_NONE), # 피
    (OG_CARD_TYPE_COVER, OG_CARD_SUB_TYPE_NONE), # 피
    # 10 단풍
    (OG_CARD_TYPE_TEN, OG_CARD_SUB_TYPE_NONE), # 열끗
    (OG_CARD_TYPE_BELT, OG_CARD_SUB_TYPE_BLUE), # 띠, 청단
    (OG_CARD_TYPE_COVER, OG_CARD_SUB_TYPE_NONE), # 피
    (OG_CARD_TYPE_COVER, OG_CARD_SUB_TYPE_NONE), # 피
    # 11 오동
    (OG_CARD_TYPE_LIGHT, OG_CARD_SUB_TYPE_NONE), # 광
    (OG_CARD_TYPE_COVER, OG_CARD_SUB_TYPE_DOUBLE), # 피, 쌍피
    (OG_CARD_TYPE_COVER, OG_CARD_SUB_TYPE_NONE), # 피
    (OG_CARD_TYPE_COVER, OG_CARD_SUB_TYPE_NONE), # 피
    # 12 비
    (OG_CARD_TYPE_LIGHT, OG_CARD_SUB_TYPE_NONE), # 광(비광)
    (OG_CARD_TYPE_TEN, OG_CARD_SUB_TYPE_NONE), # 열끗, 
    (OG_CARD_TYPE_BELT, OG_CARD_SUB_TYPE_NONE), # 띠(초단아님)
    (OG_CARD_TYPE_COVER, OG_CARD_SUB_TYPE_DOUBLE)# 피, 쌍피
    # 조커
#    ( OG_CARD_TYPE_JOKER, OG_CARD_SUB_TYPE_DOUBLE ), # 조커, 투피
#    ( OG_CARD_TYPE_JOKER, OG_CARD_SUB_TYPE_TRIPLE ) # 조커, 삼피
)

SPRD_POSITION = (
    # top
    (CARD_PSTN_OPEN_TOP_X(0), CARD_PSTN_OPEN_TOP_Y()), 
    (CARD_PSTN_OPEN_TOP_X(1), CARD_PSTN_OPEN_TOP_Y()), 
    # right
    (CARD_PSTN_OPEN_RIGHT_X(), CARD_PSTN_OPEN_RIGHT_Y(0)), 
    (CARD_PSTN_OPEN_RIGHT_X(), CARD_PSTN_OPEN_RIGHT_Y(1)), 
    # bottom
    (CARD_PSTN_OPEN_BOTTOM_X(1), CARD_PSTN_OPEN_BOTTOM_Y()), 
    (CARD_PSTN_OPEN_BOTTOM_X(0), CARD_PSTN_OPEN_BOTTOM_Y()), 
    # left
    (CARD_PSTN_OPEN_LEFT_X(), CARD_PSTN_OPEN_LEFT_Y(1)), 
    (CARD_PSTN_OPEN_LEFT_X(), CARD_PSTN_OPEN_LEFT_Y(0)), 
    # 8장을 초과 top
    (CARD_PSTN_OPEN_LEFT_X(), CARD_PSTN_OPEN_LEFT_Y(0) - CARD_NML_HEIGHT \
                                - CARD_SPC_OPEN), 
    (CARD_PSTN_OPEN_RIGHT_X(), CARD_PSTN_OPEN_RIGHT_Y(0) - CARD_NML_HEIGHT \
                                - CARD_SPC_OPEN), 
    # 8장 초과 right
    (CARD_PSTN_OPEN_RIGHT_X() \
        + CARD_NML_WIDTH + CARD_SPC_OPEN, CARD_PSTN_OPEN_RIGHT_Y(0)), 
    (CARD_PSTN_OPEN_RIGHT_X() \
        + CARD_NML_WIDTH + CARD_SPC_OPEN, CARD_PSTN_OPEN_RIGHT_Y(1)), 
    # 8장 초과 bottom
    (CARD_PSTN_OPEN_RIGHT_X(), CARD_PSTN_OPEN_RIGHT_Y(2)), 
    (CARD_PSTN_OPEN_LEFT_X(), CARD_PSTN_OPEN_LEFT_Y(2)), 
    # 8장 초과 left
    (CARD_PSTN_OPEN_LEFT_X() \
        - CARD_NML_WIDTH - CARD_SPC_OPEN, CARD_PSTN_OPEN_LEFT_Y(1)), 
    (CARD_PSTN_OPEN_LEFT_X() \
        - CARD_NML_WIDTH - CARD_SPC_OPEN, CARD_PSTN_OPEN_LEFT_Y(0))
)

KEY_SPRD_SIGL_ID = "single_id"
KEY_SPRD_MLTI_ID = "multi_id"
KEY_SPRD_FRST_ID = "first_id"
KEY_SPRD_SCND_ID = "second_id"
KEY_SPRD_EMPT_ID = "empty_id"
KEY_SPRD_MTCH_CNT = "match_cnt"
