import gobject
import pygst
pygst.require('0.10')

import gst
import gst.interfaces

from ogconf import *

class OgSndCore:
	def __init__(self):
		self.playing = False
		self.player = gst.element_factory_make("playbin", "player")

		bus = self.player.get_bus()
		bus.add_signal_watch()
		bus.connect('message', self.on_message)

	def on_message(self, bus, message):
		t = message.type
		if t == gst.MESSAGE_ERROR:
			err, debug = message.parse_error()
			print "Error: %s" % err, debug
			self.playing = False
			self.stop()
		elif t == gst.MESSAGE_EOS:
			self.playing = False
			self.stop()
	
	def set_location(self, location):
		self.player.set_property('uri', location)
	
	def query_playing_pos(self):
		"(pos, dur) tuple will return."
		try:
			position, format = self.player.query_position(gst.FORMAT_TIME)
		except:
			position = gst.CLOCK_TIME_NONE

		try:
			duration, format = self.player.query_duration(gst.FORMAT_TIME)
		except:
			duration = gst.CLOCK_TIME_NONE

		return (position, duration)
	
	def play(self):
		self.player.set_state(gst.STATE_PLAYING)
		self.playing = True

	def stop(self):
		# In this status, Resources will free. 
		self.player.set_state(gst.STATE_NULL)

	def pause(self):
		self.player.set_state(gst.STATE_PAUSED)
		self.playing = False

	def is_playing(self):
		return self.playing

class OgSound:
	def __init__(self, sndnum):

		g = OgSndCore()
		if sndnum == 1:
			g.set_location("file://" + SND_PREFIX + "/tick.wav")
		elif sndnum == 2:
			g.set_location("file://" + SND_PREFIX + "/dang.ogg")
		g.play()
