/* 프로그램 전반 상수

   This file is part of otak-godori.

   Copyright (C) 2007 Otak-godori Project.

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  
*/

#ifndef OGDEFINE_H_
#define OGDEFINE_H_

/*
 * UI. 화투장 아이템
 */
#define CARD_NML_WIDTH  40  /* 화투장 기본 넓이 */
#define CARD_NML_HEIGHT 62  /* 화투장 기본 높이 */

/*
 * UI. 화투장 배치
 */
#define CARD_SPC_OPEN_FROM_REMAIN_W 85  /* 가운데 패와 바닥패 사이 옆 간격 */
#define CARD_SPC_OPEN_FROM_REMAIN_H 40  /* 가운데 패와 바닥패 사이 위아래 간격 */
#define CARD_SPC_OPEN               45  /* 바닥패들의 사이 간격 */
#define CARD_SPC_OVER               8   /* 바닥패가 여러장 쌓일경우 사선 간격 */

#define CARD_PSTN_REMAIN_X          240 /* 가운데 패 X 좌표 */
#define CARD_PSTN_REMAIN_Y          319 /* 가운데 패 Y 좌표 */
/* 바닥패 위 X, Y 좌표 */
#define CARD_PSTN_OPEN_TOP_X(id)    (CARD_PSTN_REMAIN_X - (CARD_NML_WIDTH / 2) - (CARD_SPC_OPEN / 2)) \
                                        + ((CARD_NML_WIDTH + CARD_SPC_OPEN) * id)
#define CARD_PSTN_OPEN_TOP_Y        CARD_PSTN_REMAIN_Y - CARD_NML_HEIGHT - CARD_SPC_OPEN_FROM_REMAIN_H
/* 바닥패 오른쪽 X, Y 좌표 */
#define CARD_PSTN_OPEN_RIGHT_X      CARD_PSTN_REMAIN_X + CARD_NML_WIDTH + CARD_SPC_OPEN_FROM_REMAIN_W
#define CARD_PSTN_OPEN_RIGHT_Y(id)  (CARD_PSTN_REMAIN_Y - (CARD_NML_HEIGHT / 2) - (CARD_SPC_OPEN / 2)) \
                                        + ((CARD_NML_HEIGHT + CARD_SPC_OPEN) * id)
/* 바닥패 아래쪽 X, Y 좌표 */
#define CARD_PSTN_OPEN_BOTTOM_X(id) CARD_PSTN_OPEN_TOP_X(id)
#define CARD_PSTN_OPEN_BOTTOM_Y     CARD_PSTN_REMAIN_Y + CARD_NML_HEIGHT + CARD_SPC_OPEN_FROM_REMAIN_H
/* 바닥패 왼쪽 X, Y 좌표 */
#define CARD_PSTN_OPEN_LEFT_X       CARD_PSTN_REMAIN_X - CARD_NML_WIDTH - CARD_SPC_OPEN_FROM_REMAIN_W
#define CARD_PSTN_OPEN_LEFT_Y(id)   CARD_PSTN_OPEN_RIGHT_Y(id)


#define CARD_SPC_PLYR_HIDDEN                    1   /* 플레이어 패 사이 간격 */

#define CARD_COUNT_PLYR_BY_LINE                 10  /* 플레이어 패 한줄에 놓는 수 */
/* 플레이어 패 X, Y 좌표 */
#define CARD_PSTN_PLYR_HIDN_X(plyr_id, id)      (plyr_id == 0 ? 30 : 30) \
                                                    + ((id % CARD_COUNT_PLYR_BY_LINE) \
                                                            * (CARD_NML_WIDTH + CARD_SPC_PLYR_HIDDEN))
#define CARD_PSTN_PLYR_HIDN_Y(plyr_id, line_id) (plyr_id == 0 ? 10 : 628) \
                                                    + ((line_id) * (CARD_NML_HEIGHT + CARD_SPC_PLYR_HIDDEN))

#define CARD_SPC_PSTN                           20
/* 먹은 점수패 광 */
#define CARD_PSTN_PLYR_PNT_LGHT_X(plyr_id, id)  (plyr_id == 0 ? 500 : 500) + (CARD_SPC_PSTN * id)
#define CARD_PSTN_PLYR_PNT_LGHT_Y(plyr_id)      (plyr_id == 0 ? 10 : 628)

/* 먹은 점수패 열끗 */
#define CARD_PSTN_PLYR_PNT_TEN_X(plyr_id, id)   (plyr_id == 0 ? 630 : 630) + (CARD_SPC_PSTN * id)
#define CARD_PSTN_PLYR_PNT_TEN_Y(plyr_id)       (plyr_id == 0 ? 80 : 558)

/* 먹은 점수패 띠 */
#define CARD_PSTN_PLYR_PNT_BLT_X(plyr_id, id)   (plyr_id == 0 ? 630 : 630) + (CARD_SPC_PSTN * id)
#define CARD_PSTN_PLYR_PNT_BLT_Y(plyr_id)       (plyr_id == 0 ? 10 : 628)

/* 먹은 점수패 피(껍데기) */
#define CARD_PSTN_PLYR_PNT_CVR_X(plyr_id, id)   (plyr_id == 0 ? 860 : 860) + (CARD_SPC_PSTN * (id % 5))
#define CARD_PSTN_PLYR_PNT_CVR_Y(plyr_id, id)   (plyr_id == 0 ? 10  + ((id / 5) * 70) \
                                                              : 628 - ((id / 5) * 70))

#endif /*OGDEFINE_H_*/
