/* 게임 실행 소스

   This file is part of otak-godori.

   Copyright (C) 2007 Otak-godori Project.

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  
*/

#include <gtk/gtk.h>

#include "otak-lib/otak-util/otsys.h"
#include "ogconf.h"
#include "ogplayui.h"



int
main (int argc,
      const char * argv[])
{
    gtk_set_locale ();

    g_thread_init (NULL);
    gdk_threads_init ();

    gtk_init (&argc, (gpointer) &argv);

    /* program init */

    /* config init */
    gchar *abs_path = ot_sys_exec_abs_path_new (argv[0]);
    og_conf_dupset_exec_abs_path (abs_path);
    abs_path = ot_sys_g_free (abs_path);

    /* ui module init */
    og_play_ui_init ();

    /* main window show */
    gtk_widget_show (og_play_ui_get_window ());

// TODO : test
og_ui_test();

    gtk_main ();

    return 0;
}
