/* 버튼 위젯 헤더

   This file is part of otak-godori.

   Copyright (C) 2007 Otak-godori Project.

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with thi4s program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  
*/

#ifndef OGBUTTON_H_
#define OGBUTTON_H_

#include <gtk/gtkdrawingarea.h>

G_BEGIN_DECLS

#define OG_TYPE_BUTTON              (og_button_get_type ())
#define OG_BUTTON(obj)              (G_TYPE_CHECK_INSTANCE_CAST ((obj), OG_TYPE_BUTTON, OgButton))
#define OG_BUTTON_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), OG_TYPE_BUTTON, OgButtonClass))
#define OG_IS_BUTTON(obj)           (G_TYPE_CHECK_INSTANCE_TYPE ((obj), OG_TYPE_BUTTON))
#define OG_IS_BUTTON_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), OG_TYPE_BUTTON))
#define OG_BUTTON_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), OG_TYPE_BUTTON, OgButtonClass))


typedef struct _OgButton        OgButton;
typedef struct _OgButtonClass   OgButtonClass;

typedef enum
{
    OG_BUTTON_TYPE_NORMAL   = 0,
    OG_BUTTON_TYPE_OVER     = 1,
    OG_BUTTON_TYPE_PRESS    = 2,
    OG_BUTTON_TYPE_DISABLE  = 3,
    OG_BUTTON_TYPE_COUNT    = 4
} OgButtonType;

struct _OgButton
{
    GtkDrawingArea darea;

    GdkPixbuf *pixbufs[OG_BUTTON_TYPE_COUNT];
    
    gint curr_type;

    gshort width;
    gshort height;

    gboolean disable;
};

struct _OgButtonClass {
    GtkDrawingAreaClass parent_class;
};

GType       og_button_get_type      (void);
OgButton*   og_button_new_from_file (const gchar    *filename,
                                     gint            width,
                                     gint            height);
OgButton*   og_button_free          (OgButton *button);
void        og_button_change_type   (OgButton       *button,
                                     OgButtonType    type);

G_END_DECLS

#endif /*OGBUTTON_H_*/
